routes/web.php
<?php

use App\Http\Controllers\AdresseController;
use App\Http\Controllers\CaracteristiqueController;
use App\Http\Controllers\CategorieProduitController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\ClimatController;
use App\Http\Controllers\CommandeController;
use App\Http\Controllers\DinosaureController;
use App\Http\Controllers\EnclosController;
use App\Http\Controllers\EnvironnementController;
use App\Http\Controllers\EspeceController;
use App\Http\Controllers\PersonnelController;
use App\Http\Controllers\ProduitController;
use App\Http\Controllers\TaxeController;
use App\Http\Controllers\TypeEnclosController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Route::get('/dashboard', function () {
//    return view('dashboard');
//})->middleware(['auth'])->name('dashboard');
//
//require __DIR__.'/auth.php';

Route::get('/admin', function () {
    return view('pages/admin/index');
})->middleware(['auth'])->name('admin.index');

Route::prefix('admin')->middleware(['auth'])->group(function () {
    Route::resource('/personnels', PersonnelController::class);
    Route::resource('/enclos', EnclosController::class);
    Route::resource('/taxes', TaxeController::class);
    Route::resource('/produits', ProduitController::class);
    Route::resource('/categories-produits', CategorieProduitController::class);
    Route::resource('/dinosaures', DinosaureController::class);
    Route::resource('/especes', EspeceController::class);
    Route::resource('/caracteristiques', CaracteristiqueController::class);
    Route::resource('/climats', ClimatController::class);
    Route::resource('/environnements', EnvironnementController::class);
    Route::resource('/types-enclos', TypeEnclosController::class);
    Route::resource('/adresses', AdresseController::class);
//    Route::resource('/clients', ClientController::class);
    Route::get('/clients', [ClientController::class, 'index'])->name('clients.index');
    Route::get('/clients/{client}/edit', [ClientController::class, 'edit'])->name('clients.edit');
    Route::put('/clients/{client}', [ClientController::class, 'update'])->name('clients.update');
    Route::delete('/clients/{client}', [ClientController::class, 'destroy'])->name('clients.destroy');
});

require __DIR__.'/auth.php';

Route::get('/clients/create/{userId}', [ClientController::class, 'create'])->name('clients.create');
Route::post('/clients', [ClientController::class, 'store'])->name('clients.store');
Route::post('/clients/{client}', [ClientController::class, 'store'])->name('clients.show');

Route::post('/adresse', [AdresseController::class, 'store'])->name('adresse.store');
Route::get('/boutique', [CommandeController::class, 'index'])->name('boutique.index');
Route::post('/panier', [CommandeController::class, 'create'])->name('panier.create');
Route::put('/panier', [CommandeController::class, 'store'])->middleware(['auth'])->name('panier.store');

Route::get('/', [DinosaureController::class, 'homepage'])->name('homepage');

app/Models/Personnel.php
<?php

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Personnel extends Model
{
    use HasFactory;

    protected $fillable = ['nom', 'prenom', 'tel', 'email', 'type_id', 'adresse_id'];

    public function enclos(){
        return $this->belongsToMany(Enclos::class, 'enclos_personnel');
    }

    public function typePersonnel(){
        return $this->belongsTo(TypePersonnel::class, 'type_id');
    }

    public function adresse(){
        return $this->belongsTo(Adresse::class);
    }

    public function getBeautifulDateAttribute() {
        $dt = new Carbon($this->attributes['created_at']);
        return $dt->format('d/m/Y');
    }
}

app/Http/Controllers/PersonnelController.php
<?php

namespace App\Http\Controllers;

use App\Models\Adresse;
use App\Models\Personnel;
use App\Models\TypePersonnel;
use Illuminate\Http\Request;

class PersonnelController extends Controller
{
    public function index() {
        $staff = Personnel::with(['typePersonnel', 'adresse'])
            ->select(['id','prenom', 'nom', 'type_id', 'adresse_id','email', 'tel', 'created_at'])
            ->get();

        return view('pages/admin/personnel/index', ['staff' => $staff]);
    }

    public function store(Request $request) {
        Personnel::create(array_merge($request->all(), ["type_id" => $request->poste]));
        return redirect()->route('personnels.index');
    }

    public function create() {
        $postes = TypePersonnel::pluck('nom','id');
        return view('pages/admin/personnel/create', ['postes' => $postes]);
    }

    public function show(Personnel $personnel) {
        $staffMember = Personnel::with(['typePersonnel', 'adresse', 'enclos'])
            ->select(['id', 'prenom', 'nom', 'type_id', 'adresse_id','email', 'tel', 'created_at'])
            ->where('id', $personnel->id)
            ->firstOrFail();
        return view('pages/admin/personnel/show', ["staffMember" => $staffMember]);
    }

    public function update(Request $request, Personnel $personnel) {
        $personnel->update($request->all());
        return redirect()->route('personnels.index');
    }

    public function edit(Personnel $personnel) {
        $postes = TypePersonnel::pluck('nom', 'id');
        return view('pages/admin/personnel/edit', [
            "personnel" => $personnel,
            "postes" => $postes
        ]);
    }

    public function destroy(Personnel $personnel) {
        $personnel->delete();
        return redirect()->route('personnels.index');
    }


}

resources/views/pages/admin/personnel/create.blade.php
@extends('layouts.admin-layout')

@section('content')
    <div class="alert alert-success" style="display:none"></div>
    <div class="row">
        <div class="col-md-4">
            Photo
        </div>
        <div class="col-md-8">
            {!! Form::open(["method" => "POST", "route" => ["personnels.store"]]) !!}
            <label for="prenom">Prénom</label>
            {!! Form::text("prenom", null, ["class" => "form-group form-control"]) !!}
            <label for="nom">Nom</label>
            {!! Form::text("nom", null, ["class" => "form-group form-control"]) !!}
            <label for="tel">Numéro de téléphone</label>
            {!! Form::text("tel", null, ["class" => "form-group form-control"]) !!}
            <label for="email">Adresse e-mail</label>
            {!! Form::email("email", null, ["class" => "form-group form-control"]) !!}

            <div>
                <button type="button" class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#new-address" id="new-address-btn">
                    Ajouter une adresse
                </button>
                <div id="new-user-address">
                    <p><span id="numero"></span> <span id="rue"></span></p>
                    <p><span id="cp"></span> <span id="ville"></span></p>
                </div>
                <input type="hidden" name="adresse_id" id="adresse-id" value="">
            </div>




            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label for="poste" class="input-group-text text-dark">Poste</label>
                </div>
                {!! Form::select("poste", $postes, ["class" => "custom-select"]) !!}
            </div>
            {!! Form::submit("Enregistrer", ["class" => "btn btn-success"]) !!}
            {!! Form::close() !!}
        </div>
    </div>


    <!-- Modal -->
    <div class="modal fade" id="new-address" tabindex="-1" aria-labelledby="modal-new-address" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Ajouter une adresse</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    {!! Form::open(["method" => "POST", "route" => ["adresse.store"], "id" => "new-address-form"] ) !!}
                    <label for="numero">Numéro</label>
                    {!! Form::number("numero", null, ["class" => "form-group form-control"]) !!}
                    <label for="rue">Rue</label>
                    {!! Form::text("rue", null, ["class" => "form-group form-control"]) !!}
                    <label for="cp">Code Postal</label>
                    {!! Form::text("cp", null, ["class" => "form-group form-control"]) !!}
                    <label for="ville">Ville</label>
                    {!! Form::text("ville", null, ["class" => "form-group form-control"]) !!}

                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Fermer</button>
                        <button type="button" id="save-address" class="btn btn-primary" data-bs-dismiss="modal">Enregistrer l'adresse</button>
                    </div>

                    {!! Form::close() !!}
                </div>

            </div>
        </div>
    </div>
@endsection

resources/views/pages/admin/personnel/edit.blade.php
@extends('layouts.admin-layout')

@section('content')
    <div class="row">
        <div class="col-md-4">
            Photo
        </div>
        <div class="col-md-8">
            {!! Form::model($personnel, ["method" => "PUT", "route" => ["personnels.update", "personnel" => $personnel]]) !!}
            <label for="prenom">Prénom</label>
            {!! Form::text("prenom", $personnel->prenom, ["class" => "form-group form-control"]) !!}
            <label for="nom">Nom</label>
            {!! Form::text("nom", $personnel->nom, ["class" => "form-group form-control"]) !!}
            <label for="tel">Numéro de téléphone</label>
            {!! Form::text("tel", $personnel->tel, ["class" => "form-group form-control"]) !!}
            <label for="email">Adresse e-mail</label>
            {!! Form::email("email", $personnel->email, ["class" => "form-group form-control"]) !!}
            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label for="poste" class="input-group-text text-dark">Poste</label>
                </div>
                {!! Form::select("poste", $postes, ["class" => "custom-select"]) !!}
            </div>
            {!! Form::submit("Mettre à jour", ["class" => "btn btn-success"]) !!}
            {!! Form::close() !!}
        </div>
    </div>
@endsection

resources/views/pages/admin/personnel/index.blade.php
@extends('layouts.admin-layout')

@section('content')
    <table class="table">
        <thead class="table-dark">
            <th scope="col">Membre</th>
            <th scope="col">Poste</th>
            <th scope="col">Coordonnées</th>
            <th scope="col">Adresse</th>
            <th scope="col">Date d'ajout</th>
            <th scope="col"></th>
            <th scope="col"></th>
            <th scope="col"></th>
        </thead>
        <tbody>
            @foreach($staff as $staffMember)
                <tr>
                    <td>{{$staffMember->prenom . ' ' . $staffMember->nom}}</td>
                    <td>{{$staffMember->typePersonnel->nom}}</td>
                    <td>
                        {{$staffMember->email}} <br>
                        {{$staffMember->tel}}
                    </td>
                    <td>
                        <a href="{{ route('adresses.show', $staffMember->id) }}"><i class="fas fa-house-user"></i></a>
                    </td>
                    <td>{{$staffMember->beautiful_date}}</td>
                    <td><a href="{{ route('personnels.show', ["personnel" => $staffMember]) }}"><i class="fas fa-eye"></i></a></td>
                    <td><a href="{{ route('personnels.edit', ["personnel" => $staffMember]) }}"><i class="fas fa-user-edit"></i></a></td>
                    <td>
                        {!! Form::open(["method" => "DELETE", "route" => ["personnels.destroy", "personnel" => $staffMember]]) !!}
                        {{ Form::button('<i class="fas fa-user-minus"></i>', ['type' => 'submit', 'class' => 'btn'] )  }}

                        {!! Form::close() !!}
                    </td>
                </tr>
            @endforeach
        </tbody>
    </table>

    <a href="{{ route('personnels.create') }}" class="btn btn-primary">Ajouter un nouvel employé</a>
@endsection

resources/views/pages/admin/personnel/show.blade.php
@extends('layouts.admin-layout')

@section('content')
    <div class="row">
        <div class="col-md-4 text-center">
            <div>
                <img src="https://via.placeholder.com/200" alt="profile-picture">
            </div>
            <div>{{ $staffMember->prenom . ' ' . $staffMember->nom }}</div>
            <br>
            <div>{{ $staffMember->tel }}</div>
            <div>{{ $staffMember->email }}</div>
        </div>
        <div class="col-md-8 text-left">
            <table class="table table-striped">
                <tbody>
                    <tr>
                        <th scope="row">Date d'embauche</th>
                        <td>{{$staffMember->beautiful_date}}</td>
                    </tr>
                    <tr>
                        <th scope="row">Poste</th>
                        <td>{{$staffMember->typePersonnel->nom}}</td>
                    </tr>
                    <tr>
                        <th scope="row">Enclos actuel</th>
                    <td>
                        @foreach($staffMember->enclos as $affiliatedEnclosure)
                        <span class="mx-1">
                            {{$affiliatedEnclosure->nom}}
                        </span>
                        @endforeach
                    </td>
                    </tr>
                    <tr>
                        <th scope="row">Adresse</th>
                        <td>
                            {{$staffMember->adresse->numero . ' ' . $staffMember->adresse->rue }}
                            <br>
                            {{$staffMember->adresse->cp . ' ' . $staffMember->adresse->ville}}
                        </td>
                    </tr>
                </tbody>
            </table>

            <div class="d-flex">
                <div class="btn btn-warning mx-2">
                    <a href="{{ route('personnels.edit', ['personnel' => $staffMember]) }}">Modifier les informations</a>
                </div>
                <div class="mx-2">
                    {!! Form::open(["method" => "DELETE", "route" => ["personnels.destroy", ['personnel' => $staffMember]]]) !!}
                    {!! Form::submit("Supprimer", ["class" => "btn btn-danger"]) !!}
                    {!! Form::close() !!}
                </div>
            </div>
        </div>
    </div>
@endsection